@echo off

setlocal

set VCID=%1
set ARCH=%2


set CAMLLIB=
set OCAMLLIB=

rem Exemple de chemin : C:\οκαμλ\ocaml 4.06.1 (full)
rem Si cet exemple est le bon (?!...) il peut être copié ici puis collé dans l'invite de commande windows 10 invoquée ci-dessous (set /p OCAMLPATH=)


:0
set "REPONSE="
echo Entrer le chemin de la distribution ocaml:
set /p OCAMLPATH=
echo chemin: %OCAMLPATH%
if exist "%OCAMLPATH%\" (goto 2)
echo chemin incorrect
echo recommencer ? [o/n]
:1
set /p REPONSE=
if not "%REPONSE%" == "o" if not "%REPONSE%" == "n" echo repondre par 'o' ou par 'n' & goto 1
if "%REPONSE%" == "n" exit /B
if "%REPONSE%" == "o" goto 0
:2

set PATH=C:\windows\system32;C:\windows

if "%ARCH%" == "x64" (
	set "msvckind=msvc64"
	set outputdir=DLLGRAPHICS64\MSVC
	if "%VCID%" == "9" (
		call "C:\Program Files (x86)\Microsoft Visual Studio %VCID%.0\VC\bin\vcvarsx86_amd64.bat"
	) else (
		if %VCID% LSS 17 (
		call "C:\Program Files (x86)\Microsoft Visual Studio %VCID%.0\VC\vcvarsall.bat" x86_amd64
		) else (
			call "C:\Program Files (x86)\Microsoft Visual Studio\2017\Community\VC\Auxiliary\Build\vcvars64.bat"
		)			
	)
) else (
	set "msvckind=msvc"
	set outputdir=DLLGRAPHICS32\MSVC
	if "%ProgramFiles(x86)%" == "" (
		call "C:\Program Files\Microsoft Visual Studio %VCID%.0\VC\bin\vcvars32.bat"
	) else (
		if %VCID% LSS 17 (
		call "%ProgramFiles(x86)%\Microsoft Visual Studio %VCID%.0\VC\bin\vcvars32.bat"
		) else (
			call "C:\Program Files (x86)\Microsoft Visual Studio\2017\Community\VC\Auxiliary\Build\vcvars32.bat"
		)			
	)
)

cd COMMON\win32graph
echo.
echo On entre dans le repertoire %cd%
for /r %%i in (*.c) do (
	echo cl /nologo -D_CRT_SECURE_NO_DEPRECATE -D"_UNICODE" -D"UNICODE" /Ox /MD -I..\ocamlheaders -c %%~nxi 
	cl /nologo -D_CRT_SECURE_NO_DEPRECATE -D"_UNICODE" -D"UNICODE" /Ox /MD -I..\ocamlheaders -c %%~nxi
)
echo.

cd ..
set FLEXDLLPATH=%cd%\flexdll
set PATH=%OCAMLPATH%\bin;%FLEXDLLPATH%;%PATH%

cd flexdll
echo On entre dans le repertoire %cd%
echo cl.exe /nologo /MD -D_CRT_SECURE_NO_DEPRECATE /GS- /DMSVC  -c /Fo"flexdll_%msvckind%.obj" flexdll.c
cl.exe /nologo /MD -D_CRT_SECURE_NO_DEPRECATE /GS- /DMSVC  -c /Fo"flexdll_%msvckind%.obj" flexdll.c
echo cl.exe /nologo /MD -D_CRT_SECURE_NO_DEPRECATE /GS- -c /Fo"flexdll_initer_%msvckind%.obj" flexdll_initer.c
cl.exe /nologo /MD -D_CRT_SECURE_NO_DEPRECATE /GS- -c /Fo"flexdll_initer_%msvckind%.obj" flexdll_initer.c
cd ..

cd win32graph
echo On entre dans le repertoire %cd%
if "%ARCH%" == "x64" ( 
	..\ocmklib\%msvckind%\ocamlmklib -verbose -o graphics -oc graphics graphics.mli graphics.ml open.obj draw.obj events.obj dib.obj -ldopt "kernel32.lib gdi32.lib user32.lib" -L../flexdll
) else (
	..\ocmklib\%msvckind%\ocamlmklib -verbose  -o graphics -oc graphics graphics.mli graphics.ml open.obj draw.obj events.obj dib.obj -ldopt "kernel32.lib gdi32.lib user32.lib" -L../flexdll
)
echo.

echo Nettoyage
del *.obj *.lib *.cmo
cd ..\flexdll
del *.obj
cd ..\..

ocamlc -version > tmpfile.txt
set /p ocversion= < tmpfile.txt
set "outputd=%outputdir%\%ocversion%"
mkdir %outputd%
del tmpfile.txt

echo move COMMON\win32graph\dllgraphics.dll %outputd%
move COMMON\win32graph\dllgraphics.dll %outputd%

echo move COMMON\win32graph\*.cm* %outputd%
move COMMON\win32graph\*.cm* %outputd%

echo Resultat dans le sous-repertoire %outputd%
echo.
echo Appuyer sur une touche pour terminer...
pause > nul

