@echo off

setlocal

rem Exemple de chemin : C:\οκαμλ\ocaml 4.06.1
rem Si cet exemple est le bon (?!...) il peut être copié ici puis collé dans l'invite de commande windows 10 invoquée ci-dessous (set /p OCAMLPATH=)

set CAMLLIB=
set OCAMLLIB=

:0
set "REPONSE="
echo Entrer le chemin de la distribution ocaml:
set /p OCAMLPATH=
echo chemin: %OCAMLPATH%
if exist "%OCAMLPATH%\" (goto 2)
echo chemin incorrect
echo recommencer ? [o/n]
:1
set /p REPONSE=
if not "%REPONSE%" == "o" if not "%REPONSE%" == "n" echo repondre par 'o' ou par 'n' & goto 1
if "%REPONSE%" == "n" exit /B
if "%REPONSE%" == "o" goto 0
:2


if "%ARCH%" == "x86_64" (
	set "outputdir=DLLGRAPHICS64\MINGW"
	set "MGW=mingw64"
) else (
	set "outputdir=DLLGRAPHICS32\MINGW"
	set "MGW=mingw"
)


set FLEXDLLPATH=%cd%\COMMON\flexdll
set PATH=%FLEXDLLPATH%;%OCAMLPATH%\bin;C:\windows\system32;C:\windows;%CYGWINDIR%\bin

cd COMMON\flexdll
echo.
echo On entre dans le repertoire %cd%
echo %ARCH%-w64-mingw32-gcc.exe -c -oflexdll_%MGW%.o flexdll.c
%ARCH%-w64-mingw32-gcc.exe -c -oflexdll_%MGW%.o flexdll.c
echo %ARCH%-w64-mingw32-gcc.exe -c -oflexdll_initer_%MGW%.o flexdll_initer.c
%ARCH%-w64-mingw32-gcc.exe -c -oflexdll_initer_%MGW%.o flexdll_initer.c

cd ..\win32graph
echo.
echo On entre dans le repertoire %cd%
for /r %%i in (*.c) do (
	echo %ARCH%-w64-mingw32-gcc.exe -DUNICODE -D_UNICODE -DWINDOWS_UNICODE=1 -I../ocamlheaders -c %%~nxi 
	%ARCH%-w64-mingw32-gcc.exe -DUNICODE -D_UNICODE -DWINDOWS_UNICODE=1 -I../ocamlheaders -c %%~nxi
)
..\..\COMMON\ocmklib\%MGW%\ocamlmklib -verbose -o graphics -oc graphics graphics.mli graphics.ml open.o draw.o events.o dib.o -lkernel32 -lgdi32 -luser32 -L../flexdll

echo.
echo Nettoyage 
del *.o *.a *.cmo
cd ..\flexdll
del *.o
cd ..\..

ocamlc -version > tmpfile.txt
set /p ocversion= < tmpfile.txt
set "outputd=%outputdir%\%ocversion%"
mkdir %outputd%
del tmpfile.txt

echo move COMMON\win32graph\dllgraphics.dll %outputd%
move COMMON\win32graph\dllgraphics.dll %outputd%

echo move COMMON\win32graph\*.cm* %outputd%
move COMMON\win32graph\*.cm* %outputd%

echo Resultat dans le sous-repertoire %outputd%
echo.

  
