@echo off

echo Ce programme a pour but de munir une distribution ocaml pour Cygwin d'une bibliotheque graphique utilisable avec WinCaml.

setlocale

goto 1
:0
 echo Ceci n'est pas le chemin d'une distribution ocaml pour Cygwin valide.
:1
echo Entrer le chemin Windows de la distribution ocaml Cygwin cible ou entrer la lettre 'q' pour quitter :
set /p OCAMLDIR=
if "%OCAMLDIR%" == "q" exit /B
if not exist "%OCAMLDIR%\bin\ocaml.exe" goto 0
if not exist "%OCAMLDIR%\lib\ocaml\" goto 0 

set "OCAMLBINDIR=%OCAMLDIR%\bin"
set "OCAMLLIBDIR=%OCAMLDIR%\lib\ocaml"

set "CURRENTDIR=%cd%"
cd "%OCAMLLIBDIR%"

if exist "caml\m.h" (
findstr ARCH_SIXTYFOUR caml\m.h  > "%CURRENTDIR%\temp.txt"
) else (
	findstr ARCH_SIXTYFOUR caml\config.h  > "%CURRENTDIR%\temp.txt"
)
set /p arch64=<"%CURRENTDIR%\temp.txt"
set "arch64=%arch64:~0,22%"
cd "%CURRENTDIR%"
del temp.txt

if "%arch64%" == "#define ARCH_SIXTYFOUR" (
	echo OCaml 64 bits	
	if exist C:\cygwin64\ (set "CYGWINDIR=C:\cygwin64") else (echo installer Cygwin64 & goto fin)
	
) else (
	echo OCaml 32 bits
	if exist C:\cygwin\ (set "CYGWINDIR=C:\cygwin") else (echo installer Cygwin & goto fin)
)

echo %arch64%

if not exist %CYGWINDIR%\lib\flexdll\ (
	if  "%arch64%" == "#define ARCH_SIXTYFOUR" (
		echo installer le paquet flexdll de Cygwin64 & goto fin
	) else (
		echo installer le paquet flexdll de Cygwin & goto fin
	)
)	


set "PATH=%CYGWINDIR%\bin;C:\Windows;C:\Windows\System32"

%CYGWINDIR%\bin\bash.exe COMMON\cygwin

:fin
echo.
echo Appuyer sur une touche pour terminer...
pause > nul
